module mem_addr_gen(
  input clk,
  input rst,
  input [9:0] h_cnt,
  input [9:0] v_cnt,
  output reg [11:0] pixel_addr,
  output reg [8:0] position
);
    
reg [8:0] next_position;
  
  always @*
    if (h_cnt < 288 || h_cnt > 351)
      pixel_addr = 0;
    else if (v_cnt < position || v_cnt > position + 64)
      pixel_addr = 0;
    else 
      pixel_addr = h_cnt - 288 + 64 * (v_cnt - position);

  always @*
    if (rst)
      next_position = 0;
    else if (position < 416)
      next_position = position + 32;
    else
      next_position = 0;
    
  always @(posedge clk or posedge rst)  
    if (rst)
      position <= 8'd0;
    else
      position <= next_position;
endmodule
